/*

MetaTrader History Toolkit
hcc.mqh
v1.0
2012-11-22
Copyright  2012 Heinz Traub

*/

// This file is for the 32 bits version of MetaTrader 5.

const uint HCC_SUCCESS = 0;

enum HCC_RATES_PROPERTY
{
	Time,
	Open,
	High,
	Low,
	Close,
	Volume,
	Spread,
	TimeFrame // Renamed from "Period" because it's a global MQL5 function.
};

enum HCC_TIMEFRAME
{
	M1 = 1, // 1 Minute.
	M2 = 2, // 2 Minutes.
	M3 = 3, // 3 Minutes.
	M4 = 4, // 4 Minutes.
	M5 = 5, // 5 Minutes.
	M6 = 6, // 6 Minutes.
	M10 = 10, // 10 Minutes.
	M12 = 12, // 12 Minutes.
	M15 = 15, // 15 Minutes.
	M20 = 20, // 20 Minutes.
	M30 = 30, // 30 Minutes.
	H1 = 60, // 1 Hour.
	H2 = 120, // 2 Hours.
	H3 = 180, // 3 Hours.
	H4 = 240, // 4 Hours.
	H6 = 360, // 6 Hours.
	H8 = 480, // 8 Hours.
	H12 = 720, // 12 Hours.
	D1 = 1440, // 1 Day.
	W1 = 10080, // 1 Week.
	MN28 = 40320, // 1 Month containing 28 days.
	MN29 = 41760, // 1 Month containing 29 days.
	MN30 = 43200, // 1 Month containing 30 days.
	MN31 = 44640, // 1 Month containing 31 days.
	MN = MN30, // Standard Month.
	TM = MN * 3, // 1 Trimester.
	SM = MN * 6, // 1 Semester.
	Y1 = 525600, // 1 Year.
	LY1 = 527040 // 1 Leap year.
};

struct HCCRates
{
	uint time;
	double open;
	double high;
	double low;
	double close;
	uint volume;
	uint spread;
	uint timeframe; // Renamed from "period" to match HCC_RATES_PROPERTY.
};

#import "hcc.dll"
	uint HCCGetErrorMessage(uint code, ushort language, string &message);
	uint HCCOpenFile(const string path, uint &file);
	uint HCCCloseFile(uint file);
	uint HCCGetSymbol(uint file, string &symbol);
	uint HCCGetPrecision(uint file, uint &precision);
	uint HCCLoadHistory(uint file, uint period, uint start, uint how_many, uint &load_count);
	uint HCCGetHistoryLength(uint file, uint &length);
	uint HCCGetHistoryPeriod(uint file, uint &period);
	uint HCCGetRates(uint file, uint index, HCCRates &rates);
	uint HCCGetRatesDouble(uint file, uint index, HCC_RATES_PROPERTY prop, double &value);
	uint HCCGetRatesInteger(uint file, uint index, HCC_RATES_PROPERTY prop, uint &value);
	uint HCCExportHistoryCSV(uint file, const string csv_path, const string sep, const string decim, ushort language, uint start, uint how_many, uint &export_count);
	uint HCCExportCSV(uint file, const string csv_path, const string sep, const string decim, ushort language, uint period, uint start, uint how_many, uint &export_count);
	uint HCC2CSV(const string hcc_path, const string csv_path, const string sep, const string decim, ushort language, uint period, uint start, uint how_many, uint &export_count);
#import